swagger: "2.0"
info:
  description: "This is a toy application demostrating REST API usage.  This is not a fully 'REST-ful' implementation, it is mostly for covering the basics."
  version: "1.0.0"
  title: "Get Pizza Now - CTF Prep Lunch and Learn"
host: "54.198.135.237"
basePath: "/api/v1"
tags:
- name: "toppings_tag"
  description: "We have the most important toppings.  Especially anchovies!!! :D"
- name: "ordering"
  description: "Ordering Pizza, Updating an order, or checking on an order."
schemes:
- "http"
paths:
  /toppings:
    get:
      tags: 
      - toppings_tag
      summary: "Get a list of toppings!"
      description: "This is the valid list of toppings you can request while ordering a pizza."
      operationId: "get_toppings"
      produces:
      - "application/json"
      responses:
        "200":
          description: "successful operation"
          schema:
            $ref: "#/definitions/Toppings"

  /order_pizza:
    post:
      tags:
      - "ordering"
      summary: "Order a pizza!"
      description: ""
      operationId: "order_pizza"
      consumes:
      - "application/json"
      produces:
      - "application/json"
      parameters:
        - $ref: "#/parameters/crustParam"
        - $ref: "#/parameters/sizeParam"
        - $ref: "#/parameters/toppingsParam"
      responses:
        "200":
          description: "successful operation"
    patch:
      tags:
      - "ordering"
      summary: "Update your pizza order!"
      description: ""
      operationId: "update_pizza_order"
      consumes:
      - "application/json"
      produces:
      - "application/json"
      parameters:
        - $ref: "#/parameters/crustParam"
      responses:
        "200":
          description: "successful operation"
  /order_pizza/{order_number}:
    patch:
      tags:
      - "ordering"
      summary: "Update your pizza order!"
      description: ""
      operationId: "update_pizza_order_rest"
      consumes:
      - "application/json"
      produces:
      - "application/json"
      parameters:
        - name: "order_number"
          in: path
          type: integer
          required: True
        - $ref: "#/parameters/crustParam"
        - $ref: "#/parameters/sizeParam"
        - $ref: "#/parameters/toppingsParam"
      responses:
        "200":
          description: "successful operation"


  /check_order:
    get:
      tags:
      - "ordering"
      summary: "Check on my order."
      description: "Returns the details of your order number.  Please don't check other peoples orders.. that would be mean! :D"
      operationId: "check_order"
      produces:
      - "application/json"
      parameters:
      - name: "order_number"
        in: query
        type: "integer"
        format: "int64"
        required: True
      responses:
        "200":
          description: "successful operation"
          schema:
            $ref: "#/definitions/Result"
        "400":
          description: "Invalid query parameters."
          schema:
            $ref: "#/definitions/Result"

  /check_order/{order_number}:
    get:
      tags:
      - "ordering"
      summary: "Check on my order."
      description: "Returns the details of your order number.  Please don't check other peoples orders.. that would be mean! :D"
      operationId: "check_order_rest"
      produces:
      - "application/json"
      parameters:
      - name: "order_number"
        in: "path"
        type: "integer"
        format: "int64"
        required: True
      responses:
        "200":
          description: "successful operation"
          schema:
            $ref: "#/definitions/Result"
    
parameters:
  order_number_param:
    in: body
    name: order_number
    required: true
    schema:
      type: integer
    description: The order number you want to check or update.

  crustParam:
    in: body
    name: crust
    schema:
      type: string
      enum: [ thin, classic, stuffed ]
      example: thin
    required: true
    description: The type of crust.  Either thin, classic, or stuffed.
      
  sizeParam:
    in: body
    name: size
    required: true
    schema:
      type: string
      enum: [ small, medium, large ]
      example: small
    description: The type of crust.  Either small, medium, or large.
    
  toppingsParam:
    in: body
    name: toppings
    required: true
    schema:
      type: array
      items: 
        type: string
        enum: [ cheese, mushrooms, pepperonni, anchovies ]
      example:
      - cheese
      - mushrooms

    description: The type of crust.  Either small, medium, or large.

definitions:
  Toppings:
    type: "array"
    items: 
      type: "string"
  Result:
    type: "object"
    properties:
      success:
        type: "string"
      reason:
        type: "string"
